﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Animation;

namespace Охота_на_Cкалоедов
{
    // КЛАСС СКАЛОЕДА
    internal class Skaloed : Kartinka
    {
        int delay = 0;
        // КОНСТРУКТОР
        public Skaloed(Canvas canvas, int col, int row, int delay) : base(canvas, col, row)
        {
            Item = MainWindow.SKALOED;
            this.delay = delay;
        }

        // АНИМИРОВАННЫЙ ПЕРЕХОД
        public void Animation(int dcol, int drow)
        {
            var da = new DoubleAnimation();
            da.Duration = new Duration(TimeSpan.FromSeconds(.2));
            // небольшая задержка перед ходом:
            da.BeginTime = TimeSpan.FromMilliseconds(delay);
            if (dcol != 0)
            {
                da.By = MainWindow.CELL_WIDTH * dcol;
                BeginAnimation(Canvas.LeftProperty, da);
            }
            if (drow != 0)
            {
                da.By = MainWindow.CELL_HEIGHT * drow;
                BeginAnimation(Canvas.TopProperty, da);
            }

            // новая клетка:
            col += dcol;
            row += drow;

            //System.Console.WriteLine(Col + " " + Row);
        }

        public void AnimationTo(int col1, int col2, int row1, int row2)
        {
            var da = new DoubleAnimation();
            da.Duration = new Duration(TimeSpan.FromSeconds(.0));
            da.BeginTime = TimeSpan.FromSeconds(.4);
            if (col != 0)
            {
                da.From = MainWindow.CELL_WIDTH * col1;
                da.To = MainWindow.CELL_WIDTH * col2;
                BeginAnimation(Canvas.LeftProperty, da);
            }
            else
            {
                da.From = MainWindow.CELL_HEIGHT * row1;
                da.To = MainWindow.CELL_HEIGHT * row2;
                BeginAnimation(Canvas.TopProperty, da);
            }
            // новвя клетка:
            this.col = col2;
            this.row = row2;
        }
    }
}
