﻿using System;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Animation;


namespace Охота_на_Cкалоедов
{

    // АБСТРАКТНЫЙ КЛАСС КАРТИНКИ
    abstract class Kartinka : Image
    {
        // координаты в пикселях:
        protected int x, y;
        // координаты в клетках:
        protected int col, row;

        // канва:
        protected Canvas canvas;

        // объект в клетке:
        protected int item;


        // КОНСТРУКТОР
        public Kartinka(Canvas canvas, int col, int row)
        {
            // канва:
            this.canvas = canvas;

            // координаты в клетках:
            Col = col;
            Row = row;

            // помещаем картинку на капву:
            this.canvas.Children.Add(this);
        }

        // СВОЙСТВА

        // КОЛОНКА
        public  int Col
        {
            get => col;
            set
            {
                col = value;
                X = col * MainWindow.CELL_WIDTH;
            }
        }

        // СТРОКА
        public int Row
        {
            get => row;
            set
            {
                row = value;
                Y = row * MainWindow.CELL_HEIGHT;
            }
        }


        // ГОРИЗОНТАЛЬНАЯ КООРДИНАТА В ПИКСЕЛЯХ:
        public  int X
        {
            get => x;
            set
            {
                x = value;
                Canvas.SetLeft(this, x);
            }
        }

        // ВЕРТИКАЛЬНАЯ КООРДИНАТА В ПИКСЕЛЯХ:
        public int Y
        {
            get => y;
            set
            {
                y = value;
                Canvas.SetTop(this, y);
            }
        }

        // КАРТИНКА/ОБЪЕКТ В КЛЕТКЕ
        public  int Item
        {
            get => item;
            set
            {
                item = value;
                Source = MainWindow.images[value].Source;
            }
        }


        public void MoveTo(double newX, double newY)
        {
            var top = Canvas.GetTop(this);
            var left = Canvas.GetLeft(this);
            TranslateTransform trans = new TranslateTransform();
            this.RenderTransform = trans;
            DoubleAnimation anim1 = new DoubleAnimation(top, newY - top, TimeSpan.FromSeconds(10));
            DoubleAnimation anim2 = new DoubleAnimation(left, newX - left, TimeSpan.FromSeconds(10));
            trans.BeginAnimation(TranslateTransform.XProperty, anim1);
            trans.BeginAnimation(TranslateTransform.YProperty, anim2);
        }

        //public static void MoveTo(this Image target, double newX, double newY)
        //{
        //    var top = Canvas.GetTop(target);
        //    var left = Canvas.GetLeft(target);
        //    TranslateTransform trans = new TranslateTransform();
        //    target.RenderTransform = trans;
        //    DoubleAnimation anim1 = new DoubleAnimation(top, newY - top, TimeSpan.FromSeconds(10));
        //    DoubleAnimation anim2 = new DoubleAnimation(left, newX - left, TimeSpan.FromSeconds(10));
        //    trans.BeginAnimation(TranslateTransform.XProperty, anim1);
        //    trans.BeginAnimation(TranslateTransform.YProperty, anim2);
        //}

    }
}

