﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Animation;

namespace Бокалы
{
    class Bokal: Image
    {
        // выбранный:
        bool chose = false;
        // координаты:
        int x, y;
        // канва:
        Canvas canvas;

        // КОНСТРУКТОР
        public Bokal(Canvas canvas, int x, int y)
        {
            // канва:
            this.canvas = canvas;
            // координаты:
            X = x;
            Y = y;

            // помещаем картинку на капву:
            this.canvas.Children.Add(this);
        }

        // ГОРИЗОНТАЛЬНАЯ КООРДИНАТА В ПИКСЕЛЯХ:
        public int X
        {
            get => x;
            set
            {
                x = value;
                Canvas.SetLeft(this, x);
            }
        }

        // ВЕРТИКАЛЬНАЯ КООРДИНАТА В ПИКСЕЛЯХ:
        public int Y
        {
            get => y;
            set
            {
                y = value;
                Canvas.SetTop(this, y);
            }
        }

        // вверх?
        public bool Up { get; set; } = true;

        // выбранный:
        public bool Chose
        {
            get => chose;
            set
            {
                if (value)
                {
                    Y -= 10;
                }
                else
                {
                    Y += 10;
                }
                chose = value;
            }
        }

        // ТЕКУЩИЙ УГОЛ ПОВОРОТА
        public double Angle { get; set; } = 0;

        // ПОВОРАЧИВАЕМ БОКАЛ НА ЗАДАННЫЙ УГОЛ
        public void RotateBy(double da)
        {
            // центр трансформаций:
            var cx = MainWindow.IMAGE_WIDTH / 2;
            var cy = MainWindow.IMAGE_HEIGHT / 2;
            var trans = new RotateTransform
            {
                Angle = Angle,
                CenterX = cx,
                CenterY = cy
            };
            RenderTransform = trans;
            var animX = new DoubleAnimation(da + Angle, TimeSpan.FromSeconds(0.5));
            trans.BeginAnimation(RotateTransform.AngleProperty, animX);
            // одновляем текущий угол:
            Angle += da;
        }
    }
}
